dnl -*- m4 -*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2006 University of Colorado
dnl
dnl  Weevil is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  Weevil is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: weevil-checks.m4,v 1.2 2005/05/09 16:43:56 ywang Exp $
dnl
dnl
define( `WVL_SYS_Check_Exit', `weevil: successfully checked experiment')dnl
dnl
dnl
dnl
define( `WVL_SYS_Check_Error', ``define( `WVL_SYS_Check_Exit', ``weevil: errors encountered!
'm4exit(1)')'$1')dnl
dnl
dnl
dnl
define( `WVL_SYS_Check_Name', `weevil: checking `$1'...ifdef( `$1', `['`$1'`]', WVL_SYS_Check_Error( `error'))')dnl
dnl
dnl
define( `WVL_SYS_Check_ActorProgram', `WVL_SYS_Check_Name(`WVL_ActorProgram_'$1)
WVL_SYS_Check_Name(`WVL_ActorProgram_'$1`_style')
weevil: checking value of `WVL_ActorProgram_'$1`_style'...ifelse( WVL_SYS_Echo(`WVL_ActorProgram_'$1`_style'), `Java', `[Java]', `ifelse( WVL_SYS_Echo(`WVL_ActorProgram_'$1`_style'), `Shell', `[Shell]', WVL_SYS_Check_Error( `should be "Shell" or "Java"'))')
WVL_SYS_Check_Name(`WVL_ActorProgram_'$1`_binaryDistDir')
WVL_SYS_Check_Name(`WVL_ActorProgram_'$1`_program')
')dnl
dnl
define( `WVL_SYS_Check_Entity_Exists', `WVL_SYS_Check_Name( `WVL_Entity_'$1)')dnl
define( `WVL_SYS_Check_Component_Exists', `WVL_SYS_Check_Name( `WVL_Component_'$1)')dnl
define( `WVL_SYS_Check_Host_Exists', `WVL_SYS_Check_Name( `WVL_Host_'$1)')dnl
dnl
define( `WVL_SYS_Check_Actor', `WVL_SYS_Check_Name(`WVL_Actor_'$1)
WVL_SYS_Check_Name(`WVL_Actor_'$1`_workloadProcess')
WVL_SYS_Check_WorkloadProcess_Exists(`WVL_Actor_'$1`_workloadProcess')
WVL_SYS_Check_Name(`WVL_Actor_'$1`_program')
WVL_SYS_Check_ActorProgram(`WVL_Actor_'$1`_program')dnl
WVL_SYS_Check_Name(`WVL_Actor_'$1`_entity')
WVL_SYS_Check_Entity_Exists(`WVL_Actor_'$1`_entity')
ifdef( `WVL_Actor_'$1`_props', `WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_Actor_'$1`_'tmp)', `WVL_Actor_'$1`_props')
')')dnl
dnl
define( `WVL_SYS_Check_HostType', `WVL_SYS_Check_Name(`WVL_HostType_'$1)
')dnl
dnl
dnl
define( `WVL_SYS_Check_HostProp', `')dnl
dnl
define( `WVL_SYS_Check_Host', `WVL_SYS_Check_Name(`WVL_Host_'$1)
WVL_SYS_Check_Name(`WVL_Host_'$1`_address')
WVL_SYS_Check_Name(`WVL_Host_'$1`_account')
WVL_SYS_Check_Name(`WVL_Host_'$1`_bourneShell')
WVL_SYS_Check_Name(`WVL_Host_'$1`_weevilRoot')
WVL_SYS_Check_Name(`WVL_Host_'$1`_type')
WVL_SYS_Check_HostType( `WVL_Host_'$1`_type')dnl
ifdef( `WVL_Host_'$1`_props', `WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_Host_'$1`_'tmp)', `WVL_Host_'$1`_props')
')')dnl
dnl
dnl
define( `WVL_SYS_Check_Testbed', `WVL_SYS_Check_Name(`WVL_Testbed_'$1)
WVL_SYS_Callforeach( `WVL_SYS_Check_Host', WVL_SYS_Echo(`WVL_Testbed_'$1`_hosts'))dnl
')dnl
dnl
dnl
define( `WVL_SYS_Check_ComponentType', `WVL_SYS_Check_Name( `WVL_ComponentType_'$1)
WVL_SYS_Check_Name( `WVL_ComponentType_'$1`_startScript')
WVL_SYS_Check_Name( `WVL_ComponentType_'$1`_stopScript')
ifdef( `WVL_ComponentType_'$1`_props', `WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_ComponentType_'$1`_'tmp)', `WVL_ComponentType_'$1`_props')
')')dnl
dnl
dnl
define( `WVL_SYS_Check_Component', `WVL_SYS_Check_Name(`WVL_Component_'$1)
WVL_SYS_Check_Name( `WVL_Component_'$1`_type')
WVL_SYS_Check_ComponentType( `WVL_Component_'$1`_type')dnl
ifdef( `WVL_Component_'$1`_props', `WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_Component_'$1`_'tmp)', `WVL_Component_'$1`_props')
')')dnl
dnl
dnl
define( `WVL_SYS_Check_Relation', `WVL_SYS_Check_Name( `WVL_ComponentRelation_'$1)
WVL_SYS_Check_Name( `WVL_ComponentRelation_'$1`_name')
WVL_SYS_Check_Name( `WVL_ComponentRelation_'$1`_src')
WVL_SYS_Check_Component_Exists( WVL_SYS_Echo(`WVL_ComponentRelation_'$1`_src'))
WVL_SYS_Check_Name( `WVL_ComponentRelation_'$1`_dest')
WVL_SYS_Check_Component_Exists( WVL_SYS_Echo(`WVL_ComponentRelation_'$1`_dest'))
ifdef( `WVL_ComponentRelation_'$1`_props', `WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_ComponentRelation_'$1`_'tmp)', `WVL_ComponentRelation_'$1`_props')
')')dnl
dnl
dnl
define( `WVL_SYS_Check_SUE', `WVL_SYS_Check_Name( `WVL_SUE_'$1)
WVL_SYS_Check_Name( `WVL_SUE_'$1`_components')
WVL_SYS_Callforeach( `WVL_SYS_Check_Component',  WVL_SYS_Echo(`WVL_SUE_'$1`_components'))dnl
WVL_SYS_Check_Name( `WVL_SUE_'$1`_relations')
WVL_SYS_Callforeach( `WVL_SYS_Check_Relation',  WVL_SYS_Echo(`WVL_SUE_'$1`_relations'))dnl
')dnl
dnl
dnl
define( `WVL_SYS_Check_ComponentHost', `WVL_SYS_Check_Name( `WVL_ComponentHost_'$1)
WVL_SYS_Check_Name( `WVL_ComponentHost_'$1`_component')
WVL_SYS_Check_Component_Exists( WVL_SYS_Echo(`WVL_ComponentHost_'$1`_component'))
WVL_SYS_Check_Name( `WVL_ComponentHost_'$1`_host')
WVL_SYS_Check_Host_Exists( WVL_SYS_Echo(`WVL_ComponentHost_'$1`_host'))
ifdef( `WVL_ComponentHost_'$1`_props', `WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_ComponentHost_'$1`_'tmp)', `WVL_ComponentHost_'$1`_props')')dnl
ifdef( `WVL_ComponentHostType_'WVL_SYS_Echo(`WVL_Component_'WVL_SYS_Echo(`WVL_ComponentHost_'$1`_component')`_type')`_'WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(`WVL_ComponentHost_'$1`_host')`_type')`_props', dnl
`WVL_SYS_Foreach( `tmp', `WVL_SYS_Check_Name( `WVL_ComponentHostType_'WVL_SYS_Echo(`WVL_Component_'WVL_SYS_Echo(`WVL_ComponentHost_'$1`_component')`_type')`_'WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(`WVL_ComponentHost_'$1`_host')`_type')`_'tmp)', `WVL_ComponentHostType_'WVL_SYS_Echo(`WVL_Component_'WVL_SYS_Echo(`WVL_ComponentHost_'$1`_component')`_type')`_'WVL_SYS_Echo(`WVL_Host_'WVL_SYS_Echo(`WVL_ComponentHost_'$1`_host')`_type')`_props')')')dnl
dnl
dnl -------------- begin checks --------------------
dnl
WVL_SYS_Check_Name(`WVL_Experiment_ID')
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_workload')
dnl
define(`theWorkload', `WVL_Experiment_'WVL_Experiment_ID`_workload')dnl
WVL_SYS_Check_Name(`WVL_Workload_'theWorkload)
WVL_SYS_Check_Name(`WVL_Workload_'theWorkload`_filename')
WVL_SYS_Check_Name(`WVL_Workload_'theWorkload`_processes')
dnl
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_actors')
define(`theActors', `WVL_Experiment_'WVL_Experiment_ID`_actors')dnl
WVL_SYS_Callforeach(`WVL_SYS_Check_Actor',theActors)dnl
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_testbedload')
dnl
dnl define(`theTestbedload', `WVL_Experiment_'WVL_Experiment_ID`_testbedload')dnl
dnl WVL_SYS_Check_Name(`WVL_Testbedload_'theTestbedload)
dnl WVL_SYS_Check_Name(`WVL_Testbedload_'theTestbedload`_filename')
dnl WVL_SYS_Check_Name(`WVL_Testbedload_'theTestbedload`_processes')
dnl
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_injectors')
define(`theInjectors', `WVL_Experiment_'WVL_Experiment_ID`_injectors')dnl
WVL_SYS_Callforeach(`WVL_SYS_Check_Actor',theInjectors)dnl
dnl
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_testbed')
define( `theTestbed', `WVL_Experiment_'WVL_Experiment_ID`_testbed')dnl
WVL_SYS_Check_Testbed( theTestbed)dnl
dnl
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_sue')
define( `theSUE', `WVL_Experiment_'WVL_Experiment_ID`_sue')dnl
WVL_SYS_Check_SUE( theSUE)dnl
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_componentHosts')
define( `theCHs', `WVL_Experiment_'WVL_Experiment_ID`_componentHosts')dnl
WVL_SYS_Callforeach( `WVL_SYS_Check_ComponentHost', theCHs)dnl
dnl
WVL_SYS_Check_Name(`WVL_Experiment_'WVL_Experiment_ID`_clean')
dnl
WVL_SYS_Check_Name(`WVL_ComponentOrder_'WVL_SYS_Echo(`WVL_SUE_'theSUE`_order'))
dnl
WVL_SYS_Check_Exit
