dnl -*-m4-*-
dnl
dnl  This file is part of WEEVIL.
dnl
dnl  Authors: See the file AUTHORS for full details.
dnl
dnl  Copyright (C) 2002-2006 University of Colorado
dnl
dnl  Weevil is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  Weevil is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
dnl  USA, or send email to serl@cs.colorado.edu.
dnl
dnl $Id: weevil2hostterminate.m4,v 1.4 2005/05/16 19:20:55 ywang Exp $
dnl
define(`theHost', WVL_Host_ID)dnl
define(`theWeevilRoot', `WVL_Host_'theHost`_weevilRoot')dnl
theRoot=theWeevilRoot
changequote([[, ]])dnl
echo 'return_val=system("kill " $0);' >$theRoot/weevil_terminate_program
changequote(`, ')dnl
dnl
ifdef(`WVL_Host_'theHost`_components',, `define(`WVL_Host_'theHost`_components', `')')dnl
ifdef(`WVL_Host_'theHost`_actors',, `define(`WVL_Host_'theHost`_actors', `')')dnl
ifdef(`WVL_Host_'theHost`_injectors',, `define(`WVL_Host_'theHost`_injectors', `')')dnl
ifdef(`WVL_Host_'theHost`_monitors',, `define(`WVL_Host_'theHost`_monitors', `')')dnl
dnl
WVL_SYS_Foreach(`i', `define(`theType', `WVL_Component_'i`_type')dnl
define(`theCompPath', `theWeevilRoot`/'WVL_Experiment_Name`/'theType`/'i')dnl
sh theCompPath/WVL_Experiment_Name`_'i`_stop.sh'
', WVL_SYS_Echo(`WVL_Host_'theHost`_components'))dnl
dnl
dnl TOF: was
dnl WVL_SYS_Foreach(`i', `define(`theActorPath', `theWeevilRoot`/'WVL_Experiment_Name`/'i')dnl
dnl awk -f theWeevilRoot`/weevil_terminate_program' theActorPath/pids;
dnl ', WVL_SYS_Echo(`WVL_Host_'theHost`_actors'))dnl
dnl TOF: changed to:
WVL_SYS_Foreach(`i', `dnl
awk -f theWeevilRoot`/weevil_terminate_program' theWeevilRoot`/'WVL_Experiment_Name`/'theHost/actorstartoutput/subpids;
', theHost)dnl
dnl
WVL_SYS_Foreach(`i', `define(`theInjectorPath', `theWeevilRoot`/'WVL_Experiment_Name`/'i')dnl
awk -f theWeevilRoot`/weevil_terminate_program' theInjectorPath/pids;
', WVL_SYS_Echo(`WVL_Host_'theHost`_injectors'))dnl
dnl
WVL_SYS_Foreach(`i', `define(`theMonitorPath', `theWeevilRoot`/'WVL_Experiment_Name`/'i')dnl
awk -f theWeevilRoot`/weevil_terminate_program' theMonitorPath/pids;
', WVL_SYS_Echo(`WVL_Host_'theHost`_monitors'))dnl
